routes/web.php
<?php

use Illuminate\Support\Facades\Route;

use App\Http\Controllers\ArtistController;
use App\Http\Controllers\CinemaController;
use App\Http\Controllers\Controller;
use App\Http\Controllers\CountryController;
use App\Http\Controllers\MovieController;
use App\Http\Controllers\RoomController;
use App\Http\Controllers\SessionController;
use GuzzleHttp\Promise\Create;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [Controller::class, 'welcome']);

Route::get('/dashboard', function () {
  return view('dashboard');
})->middleware(['auth'])->name('dashboard');

Route::resource('artist', ArtistController::class);

Route::resource('country', CountryController::class);

Route::prefix('movie')->middleware('auth')->group(function () {
  Route::get('actors/{movie}', [MovieController::class, 'actors'])->name('movie.actors');
  Route::post('attach/{movie}', [MovieController::class, 'attach'])->name('movie.attach');
  Route::delete('detach/{movie}/{artist}', [MovieController::class, 'detach'])->name('movie.detach');
});


Route::resource('movie', MovieController::class);

Route::resource('cinema', CinemaController::class);

Route::resource('room', RoomController::class);

Route::resource('session', SessionController::class);


require __DIR__ . '/auth.php';

app/Models/Cinema.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Cinema extends Model
{
    use HasFactory;

    protected $fillable = ['name', 'address_line', 'city', 'country_id', 'user_id'];

    public function rooms()
    {
        return $this->hasMany(Room::class);
    }

    public function country()
    {
        return $this->belongsTo(Country::class);
    }
}

app/Http/Controllers/CinemaController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\CinemaRequest;
use App\Models\Cinema;
use App\Models\Country;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class CinemaController extends Controller
{
  /**
   * Class constructor
   */
  public function __construct()
  {
    $this->middleware('ajax')->only('destroy');
  }

  /**
   * Display a listing of the resource.
   *
   * @return \Illuminate\Http\Response
   */
  public function index()
  {
    return view('cinemas.index', ['cinemas' => Cinema::paginate(10), 'cinema' => Cinema::class]);
  }

  /**
   * Show the form for creating a new resource.
   *
   * @return \Illuminate\Http\Response
   */
  public function create()
  {
    $this->authorize('create', Cinema::class);

    return view('cinemas.create', ['countries' => Country::all()]);
  }

  /**
   * Store a newly created resource in storage.
   *
   * @param  \Illuminate\Http\Request  $request
   * @return \Illuminate\Http\Response
   */
  public function store(CinemaRequest $request)
  {
    $data = $request->all();
    $data['user_id'] = Auth::user()->id;

    Cinema::create($data);

    return redirect()->route('cinema.index')
      ->with('ok', __('Cinema has been saved !'));
  }

  /**
   * Display the specified resource.
   *
   * @param  int  $id
   * @return \Illuminate\Http\Response
   */
  public function show(Cinema $cinema)
  {
    return view('cinemas.show', [
      'cinema' => $cinema
    ]);
  }

  /**
   * Show the form for editing the specified resource.
   *
   * @param  int  $id
   * @return \Illuminate\Http\Response
   */
  public function edit(Cinema $cinema)
  {
    $this->authorize('update', $cinema);

    return view('cinemas.edit', [
      'cinema' => $cinema,
      'countries' => Country::all()
    ]);
  }

  /**
   * Update the specified resource in storage.
   *
   * @param  \Illuminate\Http\Request  $request
   * @param  int  $id
   * @return \Illuminate\Http\Response
   */
  public function update(CinemaRequest $request, Cinema $cinema)
  {
    $this->authorize('update', $cinema);

    $cinema->update($request->all());

    return redirect()->route('cinema.index')
      ->with('ok', __('Cinema has been updated !'));
  }

  /**
   * Remove the specified resource from storage.
   *
   * @param  int  $id
   * @return \Illuminate\Http\Response
   */
  public function destroy(Cinema $cinema)
  {
    $cinema->delete();

    return response()->json();
  }
}

resources/views/cinemas/create.blade.php
<x-app>
  <x-slot name="page_title">Create a Cinema</x-slot>

  <form method="POST" action="{{ route('cinema.store') }}">
    {{ csrf_field() }}
    <p>
      <label for="name">Name</label>
      <input type="text" name="name" id="name" value="" required
        class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
      <x-error name="name"></x-error>
    </p>
    <p>
      <label for="address_line">Address</label>
      <input type="text" name="address_line" id="address_line" value="" required
        class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
      <x-error name="address_line"></x-error>
    </p>
    <p>
      <label for="city">City</label>
      <input type="text" name="city" id="city" value=""
        class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
      <x-error name="city"></x-error>
    </p>
    <p>
      <label for="country_id">Country</label>
      <select name="country_id" id="country_id" required
        class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded">
        @foreach ($countries as $country)
          <option value="{{ $country->id }}">
            {{ $country->name }}
          </option>
        @endforeach
      </select>
      <x-error name="country_id"></x-error>
    </p>
    
    <button type="submit"
      class="inline-block align-middle text-center select-none border font-normal whitespace-no-wrap py-2 px-4 rounded text-base leading-normal no-underline text-blue-lightest bg-blue hover:bg-blue-light py-3 px-4 text-xl leading-tight">Create</button>
  </form>
</x-app>

resources/views/cinemas/edit.blade.php
<x-app>
    <x-slot name="page_title">Edit {{ $cinema->name }}</x-slot>

    <form method="POST" action="{{ route('cinema.update', $cinema->id) }}">
        {{ csrf_field() }}
        {{ method_field('PUT') }}

        <p>
            <label for="name">Name</label>
            <input type="text" name="name" id="name" value="{{ $cinema->name }}" required class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
            <x-error name="name"></x-error>
        </p>
        <p>
            <label for="address_line">Address</label>
            <input type="text" name="address_line" id="address_line" value="{{ $cinema->address_line }}" required class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
            <x-error name="address_line"></x-error>
        </p>
        <p>
            <label for="city">City</label>
            <input type="text" name="city" id="city" value="{{ $cinema->city }}" class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded" />
            <x-error name="city"></x-error>
        </p>
        <p>
          <label for="country_id">Country</label>
          <select name="country_id" id="country_id" required
            class="block appearance-none w-full py-1 px-2 mb-1 text-base leading-normal bg-white text-grey-darker border border-grey rounded">
            @foreach ($countries as $country)
              <option value="{{ $country->id }}" {{ $country->id === $cinema->country_id ? 'selected="selected"' : '' }}>
                {{ $country->name }}
              </option>
            @endforeach
          </select>
          <x-error name="country_id"></x-error>
        </p>

        <button type="submit" class="focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-blue-500 hover:bg-blue-600 hover:shadow-lg">
            Update
        </button>
    </form>
</x-app>

resources/views/cinemas/index.blade.php
<x-app>
  <x-slot name="page_title">Cinemas</x-slot>

  @can('create', $cinema)
    <a href="{{ route('cinema.create') }}"
      class="align-left focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-green-500 hover:bg-green-600 hover:shadow-lg">
      {{ __('New') }}
    </a>
  @endcan
  
  <table class="divide-y divide-gray-200 mt-4">
    <thead class="bg-gray-50">
      <tr>
        <th class="text-left px-2 py-3">{{ __('Name') }}</th>
        <th class="text-left px-2 py-3">{{ __('Address') }}</th>
        <th class="text-left px-2 py-3">{{ __('City') }}</th>
        <th class="text-left px-2 py-3">{{ __('Country') }}</th>
        <th class="text-left px-2 py-3">{{ __('Actions') }}</th>
      </tr>
    </thead>
    <tbody class="bg-white text-xs divide-y divide-gray-200">
      @foreach ($cinemas as $cinema)
        <tr>
          <td class="px-2 py-4">{{ $cinema->name }}</td>
          <td class="px-2 py-4">{{ $cinema->address_line }}</td>
          <td class="px-2 py-4">{{ $cinema->city }}</td>
          <td class="px-2 py-4">{{ optional($cinema->country)->name }}</td>
          <td class="px-2 py-4">
            <a href="{{ route('cinema.show', $cinema->id) }}"
              class="focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-blue-500 hover:bg-blue-600 hover:shadow-lg">
              {{ __('Show') }}
            </a>
            @can('update', $cinema)
              <a href="{{ route('cinema.edit', $cinema->id) }}"
                class="focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-blue-500 hover:bg-blue-600 hover:shadow-lg">
                {{ __('Edit') }}
              </a>
            @endcan

            @can('delete', $cinema)
              <a href="{{ route('cinema.destroy', $cinema->id) }}"
                class="delete focus:outline-none text-white text-sm py-2.5 px-5 ml-2 rounded-md bg-red-500 hover:bg-red-600 hover:shadow-lg">
                {{ __('Delete') }}
              </a>
            @endcan
          </td>
        </tr>
      @endforeach
    </tbody>
  </table>

  {{ $cinemas->links() }}

  <script>
    // Récupération du token
    let token = document.querySelector('meta[name="csrf-token"]').getAttribute('content');

    // Ajout des événements
    document.querySelectorAll('.delete').forEach(item => {
      item.addEventListener('click', event => {
        event.preventDefault();

        // Requête AJAX de suppression
        fetch(event.target.href, {
            headers: {
              'X-Requested-With': 'XMLHttpRequest',
              'X-CSRF-TOKEN': token
            },
            method: 'DELETE',
          })
          .then((data) => {
            event.target.closest('tr').remove();
          });
      })
    });

  </script>

</x-app>

resources/views/cinemas/show.blade.php
<x-app>
  <x-slot name="page_title">{{ $cinema->name }}</x-slot>

  @can('create')
    <a href="{{ route('cinema.create') }}"
      class="align-left focus:outline-none text-white text-sm py-2.5 px-5 rounded-md bg-green-500 hover:bg-green-600 hover:shadow-lg">
      {{ __('New') }}
    </a>
  @endcan

  <table class="divide-y divide-gray-200 mt-4">
    <thead class="bg-gray-50">
      <tr>
        <th class="text-left px-2 py-3">{{ __('Room id') }}</th>
        <th class="text-left px-2 py-3">{{ __('Room places') }}</th>
        <th class="text-left px-2 py-3">{{ __('Sessions') }}</th>
      </tr>
    </thead>
    <tbody class="bg-white text-xs divide-y divide-gray-200">
      @foreach ($cinema->rooms as $room)
        <tr>
          <td class="px-2 py-4">{{ $room->id }}</td>
          <td class="px-2 py-4">{{ $room->places }}</td>
          <td class="px-2 py-4">
            @foreach ($room->sessions as $session)
              <div>
                {{ $session->movie->title . ' | ' . $session->begin }}
              </div>
            @endforeach
          </td>

        </tr>
      @endforeach
    </tbody>
  </table>
</x-app>